﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{

    class DrawingControl // gotten from the web. http://stackoverflow.com/questions/487661/how-do-i-suspend-painting-for-a-control-and-its-children
    {
        [DllImport("user32.dll")]
        public static extern int SendMessage(IntPtr hWnd, Int32 wMsg, bool wParam, Int32 lParam);

        private const int WM_SETREDRAW = 11;

        public static void SuspendDrawing(Control parent)
        {
            SendMessage(parent.Handle, WM_SETREDRAW, false, 0);
        }

        public static void ResumeDrawing(Control parent)
        {
            SendMessage(parent.Handle, WM_SETREDRAW, true, 0);
            parent.Refresh();
        }
    }
 

    public static class Extensions
    {
        public static void SuspendDrawing(this Control parent)
        {
            DrawingControl.SuspendDrawing(parent);
        }
        public static void ResumeDrawing(this Control parent)
        {
            DrawingControl.ResumeDrawing(parent);
        }
        public static void MoveToCorner( this Form f, Corner c)
        {
            Positioning.moveToCorner(c, f);
        }
        public static void MagnetizeMe(this Form f)
        {
            Positioning.Magnetize(f);
        }

    }
}
