﻿using System;
using System.Diagnostics;
using System.Text;
using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Threading;


namespace WindowsFormsApplication1
{
    static class Program
    {

        static Form1 form = null;
        static Dictionary<String, UInt64> titleCounter = new Dictionary<String, UInt64>();


        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Thread t1 = new Thread(updateCount);
            t1.IsBackground = true;
            t1.Start();

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            form = new Form1();
            Application.Run(form);
        }

        [DllImport("user32.dll")]
        static extern IntPtr GetForegroundWindow();

        [DllImport("user32.dll")]
        static extern int GetWindowText(IntPtr hWnd, StringBuilder text, int count);

        private static string GetActiveWindowTitle()
        {
            const int nChars = 256;
            IntPtr handle = IntPtr.Zero;
            StringBuilder Buff = new StringBuilder(nChars);
            handle = GetForegroundWindow();

            if (GetWindowText(handle, Buff, nChars) > 0)
            {
                return Buff.ToString();
            }
            return null;
        }


        static internal List<Pair<string,ulong>> getTenMostPlus() {
            var tenmost = titleCounter.OrderByDescending(x => x.Value).Take(Math.Min(10, titleCounter.Count));
            
            List<Pair<string,ulong>> list = new List<Pair<string,ulong>>();
            foreach (var item in tenmost)
            {
                list.Add(new Pair<string,ulong>(item.Key,item.Value));
                
            }
            Debug.Assert(list.Count <= 10);
            return list;
        }
        static void updateCount()
        {
            while (true)
            {
                Thread.Sleep(1000);
                string active = GetActiveWindowTitle();
                if (active != null && form!=null && active!=form.Text)
                {
                    if (titleCounter.ContainsKey(active))
                    {
                        titleCounter[active]++;
                    }
                    else
                    {
                        titleCounter.Add(active, 1);
                    }
                }

            }
        }
    }

 
}
