﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Runtime.InteropServices;
namespace WindowsFormsApplication1
{
    partial class Form1 : Form
    {
        
        private static List<MyTrack> GetTracks(List<Pair<string,ulong>> apps)
        {
            List<MyTrack> tracks = new List<MyTrack>();
            double sum = getSum(apps);

            foreach (var pair in apps)
            {
                ulong seconds = pair.second;
                float progress = (float)(100*(seconds/sum));
                string appname = pair.first;
                tracks.Add(new MyTrack(appname,progress,seconds));
            }

            return tracks;
        }

        private void clearTracks(TableLayoutPanel table)
        { // I'm not sure everything is cleared here.
        
            table.Controls.Clear();
            
            /*  actually, no need to clear the rows (just the controls), because the number of apps only grows.
             * 
             * var styles = table.RowStyles;
            styles.Clear();
            Debug.Assert(styles.Count == 0);

            table.RowCount = styles.Count;
            int rows = table.RowCount;
            Debug.Assert(rows == 0);
            */

            table.Invalidate();
        }
        public void AddTrack(TableLayoutPanel table, MyTrack track) 
        {
            Debug.Assert(table.ColumnCount == 3); // assert NOTE: TROUBLE - depends on the UI table layout.

            table.GrowStyle = TableLayoutPanelGrowStyle.AddRows;
            RowStyle row = new RowStyle(SizeType.AutoSize);    // create a row.

            table.RowStyles.Add(row);                          // add the row.
            table.RowCount = table.RowStyles.Count;             // update the rowcount

            table.Controls.Add(track.Name,          0, table.RowStyles.Count - 1); // add the control to the last row we just added.
            table.Controls.Add(track.TimeLabel,     1, table.RowStyles.Count - 1); // add the control to the last row we just added.
            table.Controls.Add(track.Progress,      2, table.RowStyles.Count - 1); // add the control to the last row we just added.


        }

        public void AddTracks(TableLayoutPanel table, List<MyTrack> list)
        {

            foreach (var control in list)
                   AddTrack(table, control);

           table.Invalidate();
        }
    }

    public class MyTrack
    {
        Label name = null;
        public Label Name { get { return name; } }

        ProgressBar progress = null;
        public ProgressBar Progress { get { return progress; } }

        Label timeLabel = null;
        public Label TimeLabel { get { return timeLabel; } }


        public MyTrack(string extname, float extprogress, ulong seconds)
        {
            // recreates tracks every time so it's ok to put the duration in the constructor here.

            TimeSpan duration = TimeSpan.FromSeconds(seconds);
            string timefmt = duration.Hours + "h:" + duration.Minutes + "m:" + duration.Seconds + "s";

            ProgressBar p = new ProgressBar();
            Label label = new Label();
            Label timelabel = new Label();

            p.Maximum = 1000;
            p.Value = (int)(10 * extprogress);
            p.Anchor = AnchorStyles.Right | AnchorStyles.Left | AnchorStyles.Top;
            p.Height = label.Height / 2;
            this.progress = p;

            label.Text = extname;
            label.Anchor = AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Top;
            label.AutoSize = true;
            this.name = label;

            timelabel.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            timelabel.Text = timefmt;
            timelabel.AutoSize = true;
            this.timeLabel = timelabel;

        }
    }
}
